



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ZOJ 3820 Building Fire Stations</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ZOJ 3820 Building Fire Stations</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 02:27:09 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>题意：</p>
<p>树上找两个点&nbsp; 使得其它点到这两点随意一点的距离的最大&#20540;最小</p>
<p>思路：</p>
<p>最大&#20540;最小&nbsp; 想到二分&nbsp; 在二分的基础上判定这个最大&#20540;是否可能</p>
<p>怎样判定这个问题就是怎样选那两个点的问题&nbsp; 非常明显&nbsp; 我们要处理的是直径（不然没意义&nbsp; 最长的就是直径）&nbsp; 那么既然已经有了一个要判定的&#20540;x&nbsp; 最好还是就选择距离直径两端点距离为x的点就好</p>
<p>直径上的点最多n个&nbsp; 算上二分的复杂度&nbsp; O(nlogn)能够解决</p>
<p>代码：</p>
<p><pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;string&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;map&gt;<br />
#include&lt;set&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;queue&gt;<br />
#include&lt;cstdlib&gt;<br />
#include&lt;ctime&gt;<br />
#include&lt;cmath&gt;<br />
using namespace std;<br />
typedef long long LL;<br />
#define N 200010

int t, n;<br />
struct edge {<br />
	int v, next;<br />
} ed[N * 2];<br />
int head[N], tot;<br />
int dis[N], pre[N];<br />
int route[N], m;

void add(int u, int v) {<br />
	ed[tot].v = v;<br />
	ed[tot].next = head[u];<br />
	head[u] = tot++;<br />
}

int qu[N];<br />
int bfs(int u) {<br />
	int l = 0, r = 1;<br />
	int pos = u, val = 0;<br />
	dis[u] = 0;<br />
	qu[0] = u;<br />
	while (l &lt; r) {<br />
		u = qu[l++];<br />
		for (int i = head[u]; ~i; i = ed[i].next) {<br />
			int v = ed[i].v;<br />
			if (dis[v] == -1) {<br />
				pre[v] = u;<br />
				dis[v] = dis[u] + 1;<br />
				qu[r++] = v;<br />
				if (dis[v] &gt; val) {<br />
					val = dis[v];<br />
					pos = v;<br />
				}<br />
			}<br />
		}<br />
	}<br />
	return pos;<br />
}

int flag[N];<br />
bool yes(int ans) {<br />
	memset(flag, 0, sizeof(flag));<br />
	memset(dis, -1, sizeof(dis));<br />
	bfs(route[ans]);<br />
	for (int i = 1; i &lt;= n; i++) {<br />
		if (dis[i] &lt;= ans)<br />
			flag[i] = 1;<br />
	}<br />
	memset(dis, -1, sizeof(dis));<br />
	bfs(route[m - 1 - ans]);<br />
	for (int i = 1; i &lt;= n; i++) {<br />
		if (dis[i] &lt;= ans)<br />
			flag[i] = 1;<br />
	}<br />
	for (int i = 1; i &lt;= n; i++) {<br />
		if (!flag[i])<br />
			return false;<br />
	}<br />
	return true;<br />
}

int main() {<br />
	int i, u, v;<br />
	scanf(&quot;%d&quot;, &amp;t);<br />
	while (t--) {<br />
		tot = 0;<br />
		memset(head, -1, sizeof(head));<br />
		scanf(&quot;%d&quot;, &amp;n);<br />
		for (i = 1; i &lt; n; i++) {<br />
			scanf(&quot;%d%d&quot;, &amp;u, &amp;v);<br />
			add(u, v);<br />
			add(v, u);<br />
		}<br />
		memset(dis, -1, sizeof(dis));<br />
		u = bfs(1);<br />
		memset(dis, -1, sizeof(dis));<br />
		memset(pre, -1, sizeof(pre));<br />
		v = bfs(u);<br />
		m = 0;<br />
		while (v != -1) {<br />
			route[m++] = v;<br />
			v = pre[v];<br />
		}<br />
		int l = 0, r = m - 1, mid, ans[3];<br />
		while (l &lt;= r) {<br />
			mid = (l + r) / 2;<br />
			if (yes(mid)) {<br />
				ans[0] = mid;<br />
				ans[1] = route[mid];<br />
				ans[2] = route[m - 1 - mid];<br />
				if (ans[1] == ans[2]) {<br />
					for (i = 0; i &lt; m; i++) {<br />
						if (route[i] != ans[1]) {<br />
							ans[2] = route[i];<br />
							break;<br />
						}<br />
					}<br />
				}<br />
				r = mid - 1;<br />
			} else<br />
				l = mid + 1;<br />
		}<br />
		printf(&quot;%d %d %d\n&quot;, ans[0], ans[1], ans[2]);<br />
	}<br />
	return 0;<br />
}
</pre></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4k36n9.html">led驱动</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9350rzq.html">HDNOIP201404最短路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oxy118.html">C&plus;&plus; builder的文件操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wdl6lq.html">Uva 725 除法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jjy79.html">WCF学习心得------（七）消息协定</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xd1gm8.html">HTML5结构化标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k143z59.html">Python 基础【第三篇】输入和输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0rp64q.html">菜鸟的MySQL学习笔记（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zxl249.html">mac 别名 ll</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd71vmq.html">hdu2524  &lpar;求矩形个数，水题。。。&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xe2rz8.html">Python----定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zorw73q.html">使用数字签名实现数据库记录防篡改（Java实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv22ee19.html">利用Python&plus;163邮箱授权码发送带附件的邮件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll50k6q.html">JavaScript数组去重的6个方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjk4139.html">python中time模块常用功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyeg7gq.html">Java SDK夯住&lpar;Hang&rpar;问题排查</a>
		</li>
						<li><a href="https://www.batexi.com/a/9027vp4q.html">Office Web app server 2013 目前无法和windows server 2012 R2兼容。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjj7508.html">weblogic学习笔记：域创建&plus;应用部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p1ym5q.html">MySQL中EXPLAIN解释命令（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9531dz08.html">samba创建权限（复制）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4zylxe9.html">怎样使用docker不加sudo</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pov6n8.html">C：打印菱形（自己的方法）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpenxzq.html">deinstall oracle 11g on linux</a>
			</li>
						<li><a href="https://www.batexi.com/a/950x6d68.html">Cocos2d-X研究之v3&period;x瓦片地图具体解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljje519.html">搭建ganglia集群而且监视hadoop CDH4&period;6</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjj1eg8.html">ASP&period;NET&mdash;&mdash;验证码的制作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1117jq.html">GUI &amp;amp&semi; Event例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meee6pq.html">shell编程三大神器之awk</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zzome9.html">23设计模式（3）：Abstract Factory模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzz1nw8.html">【甘道夫】Hive 0&period;13&period;1 on Hadoop2&period;2&period;0 &plus; Oracle10g部署详细解释</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
